CREATE OR REPLACE TRIGGER USR_ATU_ITEMSOLI_SHA
BEFORE DELETE OR UPDATE OF IDSOLIAPROV
ON ITEMSOLI FOR EACH ROW
DECLARE
   V_NOME     VARCHAR2(1000);
   V_COMANDO  VARCHAR2(2000);
   PRAGMA AUTONOMOUS_TRANSACTION;
BEGIN
   V_NOME := 'EXPORTASOLCOMPRA';
   V_COMANDO := 'BEGIN USR_EXPORTA_SOLCOMP('||CHR(39)||V_NOME||CHR(39)||'); END;';

   IF UPDATING THEN
      IF (NVL(:NEW.IDSOLIAPROV, 'N') <> NVL(:OLD.IDSOLIAPROV, 'N')) THEN
         :NEW.USR_SHA_INTEGRADO   := 'N';
      END IF;
   END IF;
   IF DELETING THEN
      IF ((NVL(:OLD.IDSOLIAPROV, 'N') = 'N') AND (NVL(:OLD.USR_SHA_INTEGRADO, 'N') = 'N')) THEN
         RAISE_APPLICATION_ERROR(-20501, 'Operação Bloqueada: Item não pode ser excluído antes de ser integrado.');
      END IF;
   END IF;
   BEGIN
      DBMS_SCHEDULER.DROP_JOB(V_NOME);
    EXCEPTION
      WHEN OTHERS THEN
            NULL;
   END;
   BEGIN
      DBMS_SCHEDULER.CREATE_JOB (
          JOB_NAME => V_NOME,
          JOB_TYPE => 'PLSQL_BLOCK',
          JOB_ACTION => V_COMANDO,
          START_DATE => SYSDATE + INTERVAL '60' SECOND,
          ENABLED => TRUE    
      );
   END;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('USR_ATU_ITEMSOLI_SHA','6.45.017'); END;
/

